1. Registry
  2. Packages
  3. Descope Provider
  4. API Docs
  5. OauthProvider
Viewing docs for Descope v1.0.1
published on Sunday, Oct 11, 2026 by Descope
descope logo Descope
Viewing docs for Descope v1.0.1
published on Sunday, Oct 11, 2026 by Descope

    Manages a single OAuth provider in a Descope project, either the custom configuration of a built-in system provider such as Google or GitHub, or a fully custom OAuth provider. Applying this resource to an OAuth provider that was previously configured in the Descope Console takes over its configuration declaratively: console-only fields that aren’t expressible in this schema are normalized to their schema defaults on the first apply. Client secrets are write-only, so they are never read back into state, and a configured secret is preserved on the backend when the attribute is omitted from the plan. The connection endpoints of built-in system providers (such as authorizationEndpoint and tokenEndpoint) are managed by Descope and cannot be configured, so those attributes should only be set for custom providers.

    Create OauthProvider Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new OauthProvider(name: string, args: OauthProviderArgs, opts?: CustomResourceOptions);
    @overload
    def OauthProvider(resource_name: str,
                      args: OauthProviderArgs,
                      opts: Optional[ResourceOptions] = None)
    
    @overload
    def OauthProvider(resource_name: str,
                      opts: Optional[ResourceOptions] = None,
                      oauth_provider_id: Optional[str] = None,
                      project_id: Optional[str] = None,
                      jwks_endpoint: Optional[str] = None,
                      scopes: Optional[Sequence[str]] = None,
                      claim_mapping: Optional[Mapping[str, str]] = None,
                      client_auth_method: Optional[str] = None,
                      client_id: Optional[str] = None,
                      client_secret: Optional[str] = None,
                      description: Optional[str] = None,
                      disable_jit_updates: Optional[bool] = None,
                      disabled: Optional[bool] = None,
                      issuer: Optional[str] = None,
                      allowed_grant_types: Optional[Sequence[str]] = None,
                      logo: Optional[str] = None,
                      callback_domain: Optional[str] = None,
                      native_apple_key_generator: Optional[OauthProviderNativeAppleKeyGeneratorArgs] = None,
                      manage_provider_tokens: Optional[bool] = None,
                      native_client_id: Optional[str] = None,
                      native_client_secret: Optional[str] = None,
                      authorization_endpoint: Optional[str] = None,
                      apple_key_generator: Optional[OauthProviderAppleKeyGeneratorArgs] = None,
                      prompts: Optional[Sequence[str]] = None,
                      redirect_url: Optional[str] = None,
                      merge_user_accounts: Optional[bool] = None,
                      token_endpoint: Optional[str] = None,
                      use_client_assertion: Optional[bool] = None,
                      user_info_endpoint: Optional[str] = None)
    func NewOauthProvider(ctx *Context, name string, args OauthProviderArgs, opts ...ResourceOption) (*OauthProvider, error)
    public OauthProvider(string name, OauthProviderArgs args, CustomResourceOptions? opts = null)
    public OauthProvider(String name, OauthProviderArgs args)
    public OauthProvider(String name, OauthProviderArgs args, CustomResourceOptions options)
    
    type: descope:OauthProvider
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "descope_oauth_provider" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args OauthProviderArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args OauthProviderArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args OauthProviderArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args OauthProviderArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args OauthProviderArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var oauthProviderResource = new Descope.OauthProvider("oauthProviderResource", new()
    {
        OauthProviderId = "string",
        ProjectId = "string",
        JwksEndpoint = "string",
        Scopes = new[]
        {
            "string",
        },
        ClaimMapping = 
        {
            { "string", "string" },
        },
        ClientAuthMethod = "string",
        ClientId = "string",
        ClientSecret = "string",
        Description = "string",
        DisableJitUpdates = false,
        Disabled = false,
        Issuer = "string",
        AllowedGrantTypes = new[]
        {
            "string",
        },
        Logo = "string",
        CallbackDomain = "string",
        NativeAppleKeyGenerator = new Descope.Inputs.OauthProviderNativeAppleKeyGeneratorArgs
        {
            KeyId = "string",
            PrivateKey = "string",
            TeamId = "string",
        },
        ManageProviderTokens = false,
        NativeClientId = "string",
        NativeClientSecret = "string",
        AuthorizationEndpoint = "string",
        AppleKeyGenerator = new Descope.Inputs.OauthProviderAppleKeyGeneratorArgs
        {
            KeyId = "string",
            PrivateKey = "string",
            TeamId = "string",
        },
        Prompts = new[]
        {
            "string",
        },
        RedirectUrl = "string",
        MergeUserAccounts = false,
        TokenEndpoint = "string",
        UseClientAssertion = false,
        UserInfoEndpoint = "string",
    });
    
    example, err := descope.NewOauthProvider(ctx, "oauthProviderResource", &descope.OauthProviderArgs{
    	OauthProviderId: pulumi.String("string"),
    	ProjectId:       pulumi.String("string"),
    	JwksEndpoint:    pulumi.String("string"),
    	Scopes: pulumi.StringArray{
    		pulumi.String("string"),
    	},
    	ClaimMapping: pulumi.StringMap{
    		"string": pulumi.String("string"),
    	},
    	ClientAuthMethod:  pulumi.String("string"),
    	ClientId:          pulumi.String("string"),
    	ClientSecret:      pulumi.String("string"),
    	Description:       pulumi.String("string"),
    	DisableJitUpdates: pulumi.Bool(false),
    	Disabled:          pulumi.Bool(false),
    	Issuer:            pulumi.String("string"),
    	AllowedGrantTypes: pulumi.StringArray{
    		pulumi.String("string"),
    	},
    	Logo:           pulumi.String("string"),
    	CallbackDomain: pulumi.String("string"),
    	NativeAppleKeyGenerator: &descope.OauthProviderNativeAppleKeyGeneratorArgs{
    		KeyId:      pulumi.String("string"),
    		PrivateKey: pulumi.String("string"),
    		TeamId:     pulumi.String("string"),
    	},
    	ManageProviderTokens:  pulumi.Bool(false),
    	NativeClientId:        pulumi.String("string"),
    	NativeClientSecret:    pulumi.String("string"),
    	AuthorizationEndpoint: pulumi.String("string"),
    	AppleKeyGenerator: &descope.OauthProviderAppleKeyGeneratorArgs{
    		KeyId:      pulumi.String("string"),
    		PrivateKey: pulumi.String("string"),
    		TeamId:     pulumi.String("string"),
    	},
    	Prompts: pulumi.StringArray{
    		pulumi.String("string"),
    	},
    	RedirectUrl:        pulumi.String("string"),
    	MergeUserAccounts:  pulumi.Bool(false),
    	TokenEndpoint:      pulumi.String("string"),
    	UseClientAssertion: pulumi.Bool(false),
    	UserInfoEndpoint:   pulumi.String("string"),
    })
    
    resource "descope_oauth_provider" "oauthProviderResource" {
      lifecycle {
        create_before_destroy = true
      }
      oauth_provider_id = "string"
      project_id        = "string"
      jwks_endpoint     = "string"
      scopes            = ["string"]
      claim_mapping = {
        "string" = "string"
      }
      client_auth_method  = "string"
      client_id           = "string"
      client_secret       = "string"
      description         = "string"
      disable_jit_updates = false
      disabled            = false
      issuer              = "string"
      allowed_grant_types = ["string"]
      logo                = "string"
      callback_domain     = "string"
      native_apple_key_generator = {
        key_id      = "string"
        private_key = "string"
        team_id     = "string"
      }
      manage_provider_tokens = false
      native_client_id       = "string"
      native_client_secret   = "string"
      authorization_endpoint = "string"
      apple_key_generator = {
        key_id      = "string"
        private_key = "string"
        team_id     = "string"
      }
      prompts              = ["string"]
      redirect_url         = "string"
      merge_user_accounts  = false
      token_endpoint       = "string"
      use_client_assertion = false
      user_info_endpoint   = "string"
    }
    
    var oauthProviderResource = new OauthProvider("oauthProviderResource", OauthProviderArgs.builder()
        .oauthProviderId("string")
        .projectId("string")
        .jwksEndpoint("string")
        .scopes("string")
        .claimMapping(Map.of("string", "string"))
        .clientAuthMethod("string")
        .clientId("string")
        .clientSecret("string")
        .description("string")
        .disableJitUpdates(false)
        .disabled(false)
        .issuer("string")
        .allowedGrantTypes("string")
        .logo("string")
        .callbackDomain("string")
        .nativeAppleKeyGenerator(OauthProviderNativeAppleKeyGeneratorArgs.builder()
            .keyId("string")
            .privateKey("string")
            .teamId("string")
            .build())
        .manageProviderTokens(false)
        .nativeClientId("string")
        .nativeClientSecret("string")
        .authorizationEndpoint("string")
        .appleKeyGenerator(OauthProviderAppleKeyGeneratorArgs.builder()
            .keyId("string")
            .privateKey("string")
            .teamId("string")
            .build())
        .prompts("string")
        .redirectUrl("string")
        .mergeUserAccounts(false)
        .tokenEndpoint("string")
        .useClientAssertion(false)
        .userInfoEndpoint("string")
        .build());
    
    oauth_provider_resource = descope.OauthProvider("oauthProviderResource",
        oauth_provider_id="string",
        project_id="string",
        jwks_endpoint="string",
        scopes=["string"],
        claim_mapping={
            "string": "string",
        },
        client_auth_method="string",
        client_id="string",
        client_secret="string",
        description="string",
        disable_jit_updates=False,
        disabled=False,
        issuer="string",
        allowed_grant_types=["string"],
        logo="string",
        callback_domain="string",
        native_apple_key_generator={
            "key_id": "string",
            "private_key": "string",
            "team_id": "string",
        },
        manage_provider_tokens=False,
        native_client_id="string",
        native_client_secret="string",
        authorization_endpoint="string",
        apple_key_generator={
            "key_id": "string",
            "private_key": "string",
            "team_id": "string",
        },
        prompts=["string"],
        redirect_url="string",
        merge_user_accounts=False,
        token_endpoint="string",
        use_client_assertion=False,
        user_info_endpoint="string")
    
    const oauthProviderResource = new descope.OauthProvider("oauthProviderResource", {
        oauthProviderId: "string",
        projectId: "string",
        jwksEndpoint: "string",
        scopes: ["string"],
        claimMapping: {
            string: "string",
        },
        clientAuthMethod: "string",
        clientId: "string",
        clientSecret: "string",
        description: "string",
        disableJitUpdates: false,
        disabled: false,
        issuer: "string",
        allowedGrantTypes: ["string"],
        logo: "string",
        callbackDomain: "string",
        nativeAppleKeyGenerator: {
            keyId: "string",
            privateKey: "string",
            teamId: "string",
        },
        manageProviderTokens: false,
        nativeClientId: "string",
        nativeClientSecret: "string",
        authorizationEndpoint: "string",
        appleKeyGenerator: {
            keyId: "string",
            privateKey: "string",
            teamId: "string",
        },
        prompts: ["string"],
        redirectUrl: "string",
        mergeUserAccounts: false,
        tokenEndpoint: "string",
        useClientAssertion: false,
        userInfoEndpoint: "string",
    });
    
    type: descope:OauthProvider
    properties:
        allowedGrantTypes:
            - string
        appleKeyGenerator:
            keyId: string
            privateKey: string
            teamId: string
        authorizationEndpoint: string
        callbackDomain: string
        claimMapping:
            string: string
        clientAuthMethod: string
        clientId: string
        clientSecret: string
        description: string
        disableJitUpdates: false
        disabled: false
        issuer: string
        jwksEndpoint: string
        logo: string
        manageProviderTokens: false
        mergeUserAccounts: false
        nativeAppleKeyGenerator:
            keyId: string
            privateKey: string
            teamId: string
        nativeClientId: string
        nativeClientSecret: string
        oauthProviderId: string
        projectId: string
        prompts:
            - string
        redirectUrl: string
        scopes:
            - string
        tokenEndpoint: string
        useClientAssertion: false
        userInfoEndpoint: string
    

    OauthProvider Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The OauthProvider resource accepts the following input properties:

    OauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    ProjectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    AllowedGrantTypes List<string>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    AppleKeyGenerator Descope.OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    AuthorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    CallbackDomain string
    Use a custom domain in your OAuth verification screen.
    ClaimMapping Dictionary<string, string>
    Maps OAuth provider claims to Descope user attributes.
    ClientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    ClientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    ClientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    Description string
    A brief description of the OAuth provider.
    DisableJitUpdates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    Disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    Issuer string
    The issuer identifier for the OAuth provider.
    JwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    Logo string
    The URL of the logo associated with the OAuth provider.
    ManageProviderTokens bool
    Whether to enable provider token management for this OAuth provider.
    MergeUserAccounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    NativeAppleKeyGenerator Descope.OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    NativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    NativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    Prompts List<string>
    Custom prompts or consent screens that users may see during OAuth authentication.
    RedirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    Scopes List<string>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    TokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    UseClientAssertion bool
    Use private key JWT (client assertion) instead of client secret.
    UserInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    OauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    ProjectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    AllowedGrantTypes []string
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    AppleKeyGenerator OauthProviderAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    AuthorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    CallbackDomain string
    Use a custom domain in your OAuth verification screen.
    ClaimMapping map[string]string
    Maps OAuth provider claims to Descope user attributes.
    ClientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    ClientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    ClientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    Description string
    A brief description of the OAuth provider.
    DisableJitUpdates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    Disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    Issuer string
    The issuer identifier for the OAuth provider.
    JwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    Logo string
    The URL of the logo associated with the OAuth provider.
    ManageProviderTokens bool
    Whether to enable provider token management for this OAuth provider.
    MergeUserAccounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    NativeAppleKeyGenerator OauthProviderNativeAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    NativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    NativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    Prompts []string
    Custom prompts or consent screens that users may see during OAuth authentication.
    RedirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    Scopes []string
    Scopes of access that the application requests from the user's account on the OAuth provider.
    TokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    UseClientAssertion bool
    Use private key JWT (client assertion) instead of client secret.
    UserInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    oauth_provider_id string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    project_id string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    allowed_grant_types list(string)
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    apple_key_generator object
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorization_endpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    callback_domain string
    Use a custom domain in your OAuth verification screen.
    claim_mapping map(string)
    Maps OAuth provider claims to Descope user attributes.
    client_auth_method string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    client_id string
    The client ID for the OAuth provider, used to identify the application to the provider.
    client_secret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description string
    A brief description of the OAuth provider.
    disable_jit_updates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer string
    The issuer identifier for the OAuth provider.
    jwks_endpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo string
    The URL of the logo associated with the OAuth provider.
    manage_provider_tokens bool
    Whether to enable provider token management for this OAuth provider.
    merge_user_accounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    native_apple_key_generator object
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    native_client_id string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    native_client_secret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    prompts list(string)
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirect_url string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes list(string)
    Scopes of access that the application requests from the user's account on the OAuth provider.
    token_endpoint string
    The URL where the application requests an access token from the OAuth provider.
    use_client_assertion bool
    Use private key JWT (client assertion) instead of client secret.
    user_info_endpoint string
    The URL where the application retrieves user information from the OAuth provider.
    oauthProviderId String
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId String
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    allowedGrantTypes List<String>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint String
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain String
    Use a custom domain in your OAuth verification screen.
    claimMapping Map<String,String>
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod String
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId String
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret String
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description String
    A brief description of the OAuth provider.
    disableJitUpdates Boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled Boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer String
    The issuer identifier for the OAuth provider.
    jwksEndpoint String
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo String
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens Boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts Boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId String
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret String
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    prompts List<String>
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl String
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes List<String>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint String
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion Boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint String
    The URL where the application retrieves user information from the OAuth provider.
    oauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    allowedGrantTypes string[]
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain string
    Use a custom domain in your OAuth verification screen.
    claimMapping {[key: string]: string}
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description string
    A brief description of the OAuth provider.
    disableJitUpdates boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer string
    The issuer identifier for the OAuth provider.
    jwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo string
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    prompts string[]
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes string[]
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    oauth_provider_id str
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    project_id str
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    allowed_grant_types Sequence[str]
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    apple_key_generator OauthProviderAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorization_endpoint str
    The URL that users are redirected to for authorization with the OAuth provider.
    callback_domain str
    Use a custom domain in your OAuth verification screen.
    claim_mapping Mapping[str, str]
    Maps OAuth provider claims to Descope user attributes.
    client_auth_method str
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    client_id str
    The client ID for the OAuth provider, used to identify the application to the provider.
    client_secret str
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description str
    A brief description of the OAuth provider.
    disable_jit_updates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer str
    The issuer identifier for the OAuth provider.
    jwks_endpoint str
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo str
    The URL of the logo associated with the OAuth provider.
    manage_provider_tokens bool
    Whether to enable provider token management for this OAuth provider.
    merge_user_accounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    native_apple_key_generator OauthProviderNativeAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    native_client_id str
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    native_client_secret str
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    prompts Sequence[str]
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirect_url str
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes Sequence[str]
    Scopes of access that the application requests from the user's account on the OAuth provider.
    token_endpoint str
    The URL where the application requests an access token from the OAuth provider.
    use_client_assertion bool
    Use private key JWT (client assertion) instead of client secret.
    user_info_endpoint str
    The URL where the application retrieves user information from the OAuth provider.
    oauthProviderId String
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId String
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    allowedGrantTypes List<String>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator Property Map
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint String
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain String
    Use a custom domain in your OAuth verification screen.
    claimMapping Map<String>
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod String
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId String
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret String
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description String
    A brief description of the OAuth provider.
    disableJitUpdates Boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled Boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer String
    The issuer identifier for the OAuth provider.
    jwksEndpoint String
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo String
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens Boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts Boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator Property Map
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId String
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret String
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    prompts List<String>
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl String
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes List<String>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint String
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion Boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint String
    The URL where the application retrieves user information from the OAuth provider.

    Outputs

    All input properties are implicitly available as output properties. Additionally, the OauthProvider resource produces the following output properties:

    Id string
    The provider-assigned unique ID for this managed resource.
    Id string
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id str
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.

    Look up Existing OauthProvider Resource

    Get an existing OauthProvider resource’s state with the given name, ID, and optional extra properties used to qualify the lookup.

    public static get(name: string, id: Input<ID>, state?: OauthProviderState, opts?: CustomResourceOptions): OauthProvider
    @staticmethod
    def get(resource_name: str,
            id: str,
            opts: Optional[ResourceOptions] = None,
            allowed_grant_types: Optional[Sequence[str]] = None,
            apple_key_generator: Optional[OauthProviderAppleKeyGeneratorArgs] = None,
            authorization_endpoint: Optional[str] = None,
            callback_domain: Optional[str] = None,
            claim_mapping: Optional[Mapping[str, str]] = None,
            client_auth_method: Optional[str] = None,
            client_id: Optional[str] = None,
            client_secret: Optional[str] = None,
            description: Optional[str] = None,
            disable_jit_updates: Optional[bool] = None,
            disabled: Optional[bool] = None,
            issuer: Optional[str] = None,
            jwks_endpoint: Optional[str] = None,
            logo: Optional[str] = None,
            manage_provider_tokens: Optional[bool] = None,
            merge_user_accounts: Optional[bool] = None,
            native_apple_key_generator: Optional[OauthProviderNativeAppleKeyGeneratorArgs] = None,
            native_client_id: Optional[str] = None,
            native_client_secret: Optional[str] = None,
            oauth_provider_id: Optional[str] = None,
            project_id: Optional[str] = None,
            prompts: Optional[Sequence[str]] = None,
            redirect_url: Optional[str] = None,
            scopes: Optional[Sequence[str]] = None,
            token_endpoint: Optional[str] = None,
            use_client_assertion: Optional[bool] = None,
            user_info_endpoint: Optional[str] = None) -> OauthProvider
    func GetOauthProvider(ctx *Context, name string, id IDInput, state *OauthProviderState, opts ...ResourceOption) (*OauthProvider, error)
    public static OauthProvider Get(string name, Input<string> id, OauthProviderState? state, CustomResourceOptions? opts = null)
    public static OauthProvider get(String name, Output<String> id, OauthProviderState state, CustomResourceOptions options)
    resources:  existingOauthProvider:    type: descope:OauthProvider    get:      id: ${id}
    import {
      to = descope_oauth_provider.example
      id = "${id}"
    }
    
    name string
    The unique name of the resulting resource.
    id Input<ID>
    The unique provider ID of the resource to look up.
    state OauthProviderState
    Known property values the provider needs, along with the ID, to find the resource. Usually not required.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resulting resource.
    id str
    The unique provider ID of the resource to look up.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resulting resource.
    id IDInput
    The unique provider ID of the resource to look up.
    state OauthProviderState
    Known property values the provider needs, along with the ID, to find the resource. Usually not required.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resulting resource.
    id Input<string>
    The unique provider ID of the resource to look up.
    state OauthProviderState
    Known property values the provider needs, along with the ID, to find the resource. Usually not required.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resulting resource.
    id Output<String>
    The unique provider ID of the resource to look up.
    state OauthProviderState
    Known property values the provider needs, along with the ID, to find the resource. Usually not required.
    options CustomResourceOptions
    Bag of options to control resource's behavior.
    The following state arguments are supported:
    AllowedGrantTypes List<string>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    AppleKeyGenerator Descope.OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    AuthorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    CallbackDomain string
    Use a custom domain in your OAuth verification screen.
    ClaimMapping Dictionary<string, string>
    Maps OAuth provider claims to Descope user attributes.
    ClientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    ClientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    ClientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    Description string
    A brief description of the OAuth provider.
    DisableJitUpdates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    Disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    Issuer string
    The issuer identifier for the OAuth provider.
    JwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    Logo string
    The URL of the logo associated with the OAuth provider.
    ManageProviderTokens bool
    Whether to enable provider token management for this OAuth provider.
    MergeUserAccounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    NativeAppleKeyGenerator Descope.OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    NativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    NativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    OauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    ProjectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    Prompts List<string>
    Custom prompts or consent screens that users may see during OAuth authentication.
    RedirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    Scopes List<string>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    TokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    UseClientAssertion bool
    Use private key JWT (client assertion) instead of client secret.
    UserInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    AllowedGrantTypes []string
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    AppleKeyGenerator OauthProviderAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    AuthorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    CallbackDomain string
    Use a custom domain in your OAuth verification screen.
    ClaimMapping map[string]string
    Maps OAuth provider claims to Descope user attributes.
    ClientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    ClientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    ClientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    Description string
    A brief description of the OAuth provider.
    DisableJitUpdates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    Disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    Issuer string
    The issuer identifier for the OAuth provider.
    JwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    Logo string
    The URL of the logo associated with the OAuth provider.
    ManageProviderTokens bool
    Whether to enable provider token management for this OAuth provider.
    MergeUserAccounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    NativeAppleKeyGenerator OauthProviderNativeAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    NativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    NativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    OauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    ProjectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    Prompts []string
    Custom prompts or consent screens that users may see during OAuth authentication.
    RedirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    Scopes []string
    Scopes of access that the application requests from the user's account on the OAuth provider.
    TokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    UseClientAssertion bool
    Use private key JWT (client assertion) instead of client secret.
    UserInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    allowed_grant_types list(string)
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    apple_key_generator object
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorization_endpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    callback_domain string
    Use a custom domain in your OAuth verification screen.
    claim_mapping map(string)
    Maps OAuth provider claims to Descope user attributes.
    client_auth_method string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    client_id string
    The client ID for the OAuth provider, used to identify the application to the provider.
    client_secret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description string
    A brief description of the OAuth provider.
    disable_jit_updates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer string
    The issuer identifier for the OAuth provider.
    jwks_endpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo string
    The URL of the logo associated with the OAuth provider.
    manage_provider_tokens bool
    Whether to enable provider token management for this OAuth provider.
    merge_user_accounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    native_apple_key_generator object
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    native_client_id string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    native_client_secret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    oauth_provider_id string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    project_id string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    prompts list(string)
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirect_url string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes list(string)
    Scopes of access that the application requests from the user's account on the OAuth provider.
    token_endpoint string
    The URL where the application requests an access token from the OAuth provider.
    use_client_assertion bool
    Use private key JWT (client assertion) instead of client secret.
    user_info_endpoint string
    The URL where the application retrieves user information from the OAuth provider.
    allowedGrantTypes List<String>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint String
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain String
    Use a custom domain in your OAuth verification screen.
    claimMapping Map<String,String>
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod String
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId String
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret String
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description String
    A brief description of the OAuth provider.
    disableJitUpdates Boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled Boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer String
    The issuer identifier for the OAuth provider.
    jwksEndpoint String
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo String
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens Boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts Boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId String
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret String
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    oauthProviderId String
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId String
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    prompts List<String>
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl String
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes List<String>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint String
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion Boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint String
    The URL where the application retrieves user information from the OAuth provider.
    allowedGrantTypes string[]
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator OauthProviderAppleKeyGenerator
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint string
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain string
    Use a custom domain in your OAuth verification screen.
    claimMapping {[key: string]: string}
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod string
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId string
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret string
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description string
    A brief description of the OAuth provider.
    disableJitUpdates boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer string
    The issuer identifier for the OAuth provider.
    jwksEndpoint string
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo string
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator OauthProviderNativeAppleKeyGenerator
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId string
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret string
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    oauthProviderId string
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId string
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    prompts string[]
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl string
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes string[]
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint string
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint string
    The URL where the application retrieves user information from the OAuth provider.
    allowed_grant_types Sequence[str]
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    apple_key_generator OauthProviderAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorization_endpoint str
    The URL that users are redirected to for authorization with the OAuth provider.
    callback_domain str
    Use a custom domain in your OAuth verification screen.
    claim_mapping Mapping[str, str]
    Maps OAuth provider claims to Descope user attributes.
    client_auth_method str
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    client_id str
    The client ID for the OAuth provider, used to identify the application to the provider.
    client_secret str
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description str
    A brief description of the OAuth provider.
    disable_jit_updates bool
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled bool
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer str
    The issuer identifier for the OAuth provider.
    jwks_endpoint str
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo str
    The URL of the logo associated with the OAuth provider.
    manage_provider_tokens bool
    Whether to enable provider token management for this OAuth provider.
    merge_user_accounts bool
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    native_apple_key_generator OauthProviderNativeAppleKeyGeneratorArgs
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    native_client_id str
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    native_client_secret str
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    oauth_provider_id str
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    project_id str
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    prompts Sequence[str]
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirect_url str
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes Sequence[str]
    Scopes of access that the application requests from the user's account on the OAuth provider.
    token_endpoint str
    The URL where the application requests an access token from the OAuth provider.
    use_client_assertion bool
    Use private key JWT (client assertion) instead of client secret.
    user_info_endpoint str
    The URL where the application retrieves user information from the OAuth provider.
    allowedGrantTypes List<String>
    The type of grants (authorizationCode or implicit) to allow when requesting access tokens from the OAuth provider.
    appleKeyGenerator Property Map
    The apple key generator object describing how to create a dynamic apple client secret for applications.
    authorizationEndpoint String
    The URL that users are redirected to for authorization with the OAuth provider.
    callbackDomain String
    Use a custom domain in your OAuth verification screen.
    claimMapping Map<String>
    Maps OAuth provider claims to Descope user attributes.
    clientAuthMethod String
    The token endpoint client authentication method: clientSecretBasic (credentials in the HTTP Basic auth header) or clientSecretPost (credentials in the request body). Empty defaults to clientSecretPost.
    clientId String
    The client ID for the OAuth provider, used to identify the application to the provider.
    clientSecret String
    The client secret for the OAuth provider, used to authenticate the application with the provider.
    description String
    A brief description of the OAuth provider.
    disableJitUpdates Boolean
    By default the user attribute mapping configuration is used to update the user's attributes automatically during sign in. Disable this if you want this to happen only during user creation.
    disabled Boolean
    Setting this to true will disallow using this OAuth provider directly via API and SDK calls. Note that this does not affect authentication flows that are configured to use this provider.
    issuer String
    The issuer identifier for the OAuth provider.
    jwksEndpoint String
    The URL where the application can retrieve JSON Web Key Sets (JWKS) for the OAuth provider.
    logo String
    The URL of the logo associated with the OAuth provider.
    manageProviderTokens Boolean
    Whether to enable provider token management for this OAuth provider.
    mergeUserAccounts Boolean
    Whether to merge existing user accounts with new ones created through OAuth authentication.
    nativeAppleKeyGenerator Property Map
    The apple key generator object describing how to create a dynamic native apple client secret for mobile apps.
    nativeClientId String
    The client ID for the OAuth provider, used for Sign in with Apple in mobile apps.
    nativeClientSecret String
    The client secret for the OAuth provider, used for Sign in with Apple in mobile apps.
    oauthProviderId String
    The OAuth provider to configure. Use one of the built-in system providers (apple, discord, facebook, github, gitlab, google, linkedin, microsoft, slack) or any other value to define a custom OAuth/OIDC provider. Changing this value will require the resource to be deleted and recreated.
    projectId String
    The ID of the project that this OAuth provider belongs to. Changing this value will require the resource to be deleted and recreated.
    prompts List<String>
    Custom prompts or consent screens that users may see during OAuth authentication.
    redirectUrl String
    Users will be directed to this URL after authentication. If redirect URL is specified in the SDK/API call, it will override this value.
    scopes List<String>
    Scopes of access that the application requests from the user's account on the OAuth provider.
    tokenEndpoint String
    The URL where the application requests an access token from the OAuth provider.
    useClientAssertion Boolean
    Use private key JWT (client assertion) instead of client secret.
    userInfoEndpoint String
    The URL where the application retrieves user information from the OAuth provider.

    Supporting Types

    OauthProviderAppleKeyGenerator, OauthProviderAppleKeyGeneratorArgs

    KeyId string
    The apple generator key id produced by Apple.
    PrivateKey string
    The apple generator private key produced by Apple.
    TeamId string
    The apple generator team id assigned to the key by Apple.
    KeyId string
    The apple generator key id produced by Apple.
    PrivateKey string
    The apple generator private key produced by Apple.
    TeamId string
    The apple generator team id assigned to the key by Apple.
    key_id string
    The apple generator key id produced by Apple.
    private_key string
    The apple generator private key produced by Apple.
    team_id string
    The apple generator team id assigned to the key by Apple.
    keyId String
    The apple generator key id produced by Apple.
    privateKey String
    The apple generator private key produced by Apple.
    teamId String
    The apple generator team id assigned to the key by Apple.
    keyId string
    The apple generator key id produced by Apple.
    privateKey string
    The apple generator private key produced by Apple.
    teamId string
    The apple generator team id assigned to the key by Apple.
    key_id str
    The apple generator key id produced by Apple.
    private_key str
    The apple generator private key produced by Apple.
    team_id str
    The apple generator team id assigned to the key by Apple.
    keyId String
    The apple generator key id produced by Apple.
    privateKey String
    The apple generator private key produced by Apple.
    teamId String
    The apple generator team id assigned to the key by Apple.

    OauthProviderNativeAppleKeyGenerator, OauthProviderNativeAppleKeyGeneratorArgs

    KeyId string
    The apple generator key id produced by Apple.
    PrivateKey string
    The apple generator private key produced by Apple.
    TeamId string
    The apple generator team id assigned to the key by Apple.
    KeyId string
    The apple generator key id produced by Apple.
    PrivateKey string
    The apple generator private key produced by Apple.
    TeamId string
    The apple generator team id assigned to the key by Apple.
    key_id string
    The apple generator key id produced by Apple.
    private_key string
    The apple generator private key produced by Apple.
    team_id string
    The apple generator team id assigned to the key by Apple.
    keyId String
    The apple generator key id produced by Apple.
    privateKey String
    The apple generator private key produced by Apple.
    teamId String
    The apple generator team id assigned to the key by Apple.
    keyId string
    The apple generator key id produced by Apple.
    privateKey string
    The apple generator private key produced by Apple.
    teamId string
    The apple generator team id assigned to the key by Apple.
    key_id str
    The apple generator key id produced by Apple.
    private_key str
    The apple generator private key produced by Apple.
    team_id str
    The apple generator team id assigned to the key by Apple.
    keyId String
    The apple generator key id produced by Apple.
    privateKey String
    The apple generator private key produced by Apple.
    teamId String
    The apple generator team id assigned to the key by Apple.

    Package Details

    Repository
    descope descope/pulumi-descope
    License
    Apache-2.0
    Notes
    This Pulumi package is based on the descope Terraform Provider.
    descope logo Descope
    Viewing docs for Descope v1.0.1
    published on Sunday, Oct 11, 2026 by Descope

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial